/*********************************************************************
 * vi:set ts=4 nowrap:
 *
 * $Id: syserrs.h,v 1.1 1998/12/06 15:30:57 nicb Exp $
 *
 * System call handlers
 *
 * These calls can be used in any system call situation, to handle
 * the trivial error cases
 *
 * Originally written by Nicola Bernardini [nicb@axnet.it]
 *
 * This module is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
#if !defined(_new_src_syscalls_h_)

int syscall_warning(const int cmd_code, const char *format, ...);
int syscall_fatal(const int cmd_code, const int exit_value, const char *format, ...);

#endif /* !defined(_new_src_syscalls_h_) */
