#include "lpc.h"	/*						UGENS5.H	*/

typedef	struct {
	OPDS	h;
	float	*kr, *ksig, *ihtim, *isig;
	float	c1, c2, yt1;
} PORT;

typedef struct {
	OPDS	h;
	float	*ar, *asig, *khp, *istor;
	float	c1, c2, yt1, prvhp;
} TONE;

typedef	struct {
	OPDS	h;
	float	*ar, *asig, *kcf, *kbw, *iscl, *istor;
	int     scale;
	float	c1, c2, c3, yt1, yt2, cosf, prvcf, prvbw;
} RESON;

typedef struct {
	OPDS	h;
	float	*ar, *asig, *khp, *ord, *istor;
	float	c1, c2, *yt1, prvhp;
	int loop;
        AUXCH	aux;
} TONEX;

typedef	struct {
	OPDS	h;
	float	*ar, *asig, *kcf, *kbw, *ord, *iscl, *istor;
	int     scale, loop;
	float	c1, c2, c3, *yt1, *yt2, cosf, prvcf, prvbw;
        AUXCH	aux;
} RESONX;

typedef struct {
	OPDS	h;
	float	*krmr, *krmo, *kerr, *kcps, *ktimpt, *ifilno, *inpoles, *ifrmrate;
	long	headlongs, npoles, nvals, lastfram16, lastmsg;
	float	kcoefs[MAXPOLES*2], framrat16;
	int	storePoles ;
	MEMFIL	*mfp;
} LPREAD;

typedef	struct {
	OPDS	h;
	float	*ar, *asig;
	float	circbuf[MAXPOLES<<1], *circjp, *jp2lim;
	LPREAD	*lpread;
} LPRESON;

typedef	struct {
	OPDS	h;
	float	*ar, *asig, *kfrqratio;
	float	past[MAXPOLES], prvratio, d, prvout;
	LPREAD	*lpread;
} LPFRESON;

typedef	struct {
	OPDS	h;
	float	*kr, *asig, *ihp, *istor;
	float	c1, c2, prvq;
} RMS;

typedef	struct {
	OPDS	h;
	float	*ar, *asig, *krms, *ihp, *istor;
	float	c1, c2, prvq, prva;
} GAIN;

typedef	struct {
	OPDS	h;
	float	*ar, *asig, *csig, *ihp, *istor;
	float	c1, c2, prvq, prvr, prva;
} BALANCE;

typedef struct {
	OPDS	h;
	float   *islotnum ; /* Assume sizeof(int)== sizeof(float) */
} LPSLOT ;

typedef struct {
	OPDS	h; 
	float   *islot1 ; 
	float   *islot2 ; /* Assume sizeof(pointer)== sizeof(float) */
	float   *kmix  ;
	float	*fpad[5]; /* Pad for kcoef correctly put (Mighty dangerous) */
	long    lpad,npoles ;
	LPREAD  *lp1,*lp2 ;
	long	lastmsg;
	float	kcoefs[MAXPOLES*2], framrat16;
	int		storePoles ;
} LPINTERPOL ;
